"""Style template to drive htp2html.py for KOE documentation.
"""
__version__ = '$Revision: 1.1 $'
#  $Source: /projects/cvsroot/koe/docs/support/style.py,v $

import os
import rfc822
import stat
import sys
import time

DEFAULT_VARIABLES = {"doctype": "-//IETF//DTD HTML 3.0//EN//",
		     "author-email": "knowboteers@cnri.reston.va.us",
		     "author": "Knowboteers",
		     "background-color": "#faebd7"}

MONTH_NAMES = "January", "February", "March", "April", "May", "June", \
	      "July", "August", "September", "October", "November", "December"

WEEKDAY_NAMES = "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", \
		"Saturday", "Sunday"


def process(fi, fo, name, file, HEAD, TAIL):
##     print "Processing", file, "..."
    depth = 0
    current = os.curdir + os.sep
    while name[:2] == current:
	name = name[len(current):]
    depth = map(None, os.getcwd()).count(os.sep)
    root = "../" * depth or "./"
    head, tail = os.path.split(name)

    variables, used = merge_dict({}, rfc822.Message(fi))
    bodytext = fi.read()
    fi.close()
    times = [mtime(file)]
    # don't allow this to be covered by parent dirs:
    if not variables.has_key("title"):
	variables["title"] = "Untitled Document"
    searchdepth = maxdepth = depth + 1
    while searchdepth:
	reldir = (os.pardir + os.sep) * (maxdepth - searchdepth)
	filename = os.path.normpath(os.path.join(head, reldir + "index.htp"))
	searchdepth = searchdepth - 1
	try:
	    fp = open(filename)
	except IOError:
	    pass
	else:
	    variables, used = merge_dict(variables, rfc822.Message(fp))
    variables, used = merge_dict(variables, DEFAULT_VARIABLES)
    times.sort()
    variables, used = merge_dict(time_dict(times[-1], "modified-"), variables)
    processed = time_dict(time.localtime(time.time()), "processed-")
    variables, used = merge_dict(processed, variables)

    # maybe add a bunch of date-related stuff here?
    # date of processing, date of .htp file, most recent of all .htp & .htt
    # files which affect the output, etc.

    fo.write(HEAD % variables)
    fo.write(bodytext)
    fo.write(TAIL % variables)


def merge_dict(primary, secondary):
    used = 0
    for key, value in secondary.items():
	if not primary.has_key(key):
	    primary[key] = value
	    used = 1
    return primary, used


def mtime(filename):
    return time.localtime(os.stat(filename)[stat.ST_MTIME])


def time_dict((year, month, day, hour, minute, second, weekday, julian, dst),
	      prefix=''):
    return {prefix + 'year': year,
	    prefix + 'year-part': year % 100,
	    prefix + 'century': year / 100,
	    prefix + 'day': day,
	    prefix + 'hour12': (hour % 12) or 12,
	    prefix + 'hour24': hour or 24,
	    prefix + 'ampm': ((hour, minute, second) <= (12, 0, 0)
			      and 'am' or 'pm'),
	    prefix + 'julian': julian,
	    prefix + 'seconds': second,
	    prefix + 'dst': dst and "DST" or '',
	    prefix + 'weekday': weekday,
	    prefix + 'weekday-name': WEEKDAY_NAMES[weekday],
	    prefix + 'weekday-abbrev': WEEKDAY_NAMES[weekday][:3],
	    prefix + 'month': month,
	    prefix + 'month-name': MONTH_NAMES[month - 1],
	    prefix + 'month-abbrev': MONTH_NAMES[month - 1][:3],
	    }

#
#  end of file
