"""Wrapper for the I/O streams for the KP to use."""

__version__ = '$Revision: 1.2 $'


from koe.interfaces.stubs import FileAPI
from koe.interfaces.stubs import FileAPI__skel


class Redirector(FileAPI__skel.File):
    __buf = ''

    def __init__(self, ifp, ofp):
        self.__ifp = ifp
        self.__ofp = ofp

    def close(self):
        try:
            self.__ofp.close()
            self.__ifp.close()
        except IOError, err:
            raise FileAPI.FileIOError, `err`

    def flush(self):
        try:
            self.__ofp.flush()
        except IOError, err:
            raise FileAPI.FileIOError, `err`

    def read(self, size=-1):
        if size < 0:
            while self.__readmore(10240):
                pass
        while len(self.__buf) < size:
            buf = self.__readmore(size - len(self.__buf))
            if not buf:
                break
        return self.__returnchars(size)

    def __readmore(self, size):
        try:
            buf = self.__ifp.read(size)
        except IOError, err:
            raise FileAPI.FileIOError, `err`
        self.__buf = self.__buf + buf
        return buf

    def __returnchars(self, size):
        buf = self.__buf[:size]
        self.__buf = self.__buf[size:]
        return buf

    def readline(self):
        while "\n" not in self.__buf:
            buf = self.__readmore(1024)
            if not buf:
                return self.__returnchars(len(self.__buf))
        if "\n" in self.__buf:
            return self.__returnchars(string.index(self.__buf, "\n") + 1)
        return self.__returnchars(len(self.__buf))

    def readlines(self):
        lines = []
        while 1:
            line = self.readline()
            if not line:
                break
            lines.append(line)
        return lines

    def seek(self, offset, whence=0):
        raise FileIOError, "seek() not supported"

    def tell(self):
        raise FileIOError, "tell() not supported"

    def write(self, buf):
        try:
            self.__ofp.write(buf)
        except IOError, err:
            raise FileAPI.FileIOError, `err`

    def writelines(self, lines):
        self.write(string.join(lines, ''))
