"""Utility functions to store and retrieve the ContentProvider registration
database."""

import os

try:
    import cPickle
except ImportError:
    import pickle
else:
    pickle = cPickle

from koe.common import pathhack


# Low level interface
DEFAULT_FILENAME = os.path.normpath(
    os.path.join(pathhack.kos_root(),             # $KOSROOT
                 'demos',
                 'provider',
                 'var',
                 'registry'))

def load(filename=DEFAULT_FILENAME):
    """Load the registration state from the persistent store."""
    return pickle.load(open(filename, 'rb'))


def save(state, filename=DEFAULT_FILENAME):
    """Save the registration state to the persistent store atomically."""
    tempname = filename + '.' + `os.getpid()`
    pickle.dump(state, open(tempname, 'wb'), 1)
    os.rename(tempname, filename)
