"""Sample KP to provide a little bit of content to the web...."""

import nstools
import string
import sys

class KP:
    def __main__(self, kos):
        self.cr_api = kos.all_exceptions("ContentRegistrarAPI")
        self.registrar = kos.lookup_service(
            "ContentRegistrarAPI.ContentRegistrar", "Registrar").Open()
        sfs = kos.get_suitcase()
        # To create the ILU true object, bind the service and then open the
        # "opaque" id to get a reference to it.
        id = kos.bind_service("my-content-provider", self,
                              "ContentProviderAPI.ContentProvider")
        try:
            self.register(sfs, id.Open())
            print "providing service"
            kos.run()
        finally:
            print 'unbinding service'
            kos.unbind_service(id)
            print 'unregister suitcase filesystem'
            self.unregister(sfs)

    def register(self, sfs, provider):
        """Register our ContentProvider interface with the content manager."""
        self.provider = sys.argv[1:] and sys.argv[1] or "sample"
        try:
            self.id = self.registrar.RegisterProvider(self.provider)
        except self.cr_api.NonUniqueNameError, err:
            self.id = err
        print "registered provider", self.id
        self.registrar.UploadStaticContent(self.id, sfs.repr)
        print "offloaded content"
        self.registrar.RegisterLiveContent(self.id, provider)
        print "dynamic content"

    def unregister(self, sfs):
        """Remove registration for both offloaded and dynamic content."""
        self.registrar.UnRegisterLiveContent(self.id)
        self.registrar.UnloadStaticContent(self.id)
        self.registrar.UnRegisterProvider(self.id)

    def GetContent(self, url, env, fp):
        """Provide content in response to a user request."""
        print "URL:", url
        while url and url[0] == '/':
            url = url[1:]
        parts = string.split(url, '/')
        url = string.join(parts[1:], '/')
        fp.write("Content-Type: text/html\n\n")
        fp.write("<html>\n  <head>\n"
                 "    <title>Output from Provider %s</title>\n"
                 "  </head>\n  <body>\n"
                 % parts[0])
        fp.write("    <h1>Content Provider %s</h1>\n\n" % parts[0])
        fp.write("    <p> <b>URL:</b><br>\n")
        fp.write("      <code>%s</code>\n\n" % url)
        fp.write("    <p> <b>Environment:</b>\n\n")
        fp.write("      <table>\n")
        for k, v in env.GetItems():
            fp.write("        <tr><td>%s</td>\n" % k)
            fp.write("            <td>%s</td></tr>\n" % v)
        fp.write("      </table>\n\n")
        if url == "quit":
            fp.write("      <hr>\n")
            fp.write("      <em>Magic URL detected...\n"
                     "          stopping dynamic server.</em>\n")
            sys.kos.stop()
        fp.write("  </body>\n</html>\n")
        fp.flush()
