"""A KP that flexes the `Registrar' service.

Launch with:

    submit.py -s .:test-suitcase testkp.py [-- -u]

so that the directory `test-suitcase' gets inserted into the suitcase of the
KP, rooted at the top directory.

If the -u option is given (to the KP), then this unloads and unregisters
instead.

"""

import sys
NonUniqueNameError = sys.kos.exception(
    'ContentRegistrarAPI.NonUniqueNameError')

class KP:
    def __main__(self, kos):
        reg = kos.lookup_service('ContentRegistrarAPI.ContentRegistrar',
                                 'Registrar').Open()
        try:
            id = reg.RegisterProvider('testkp')
            print 'got id:', id
        except NonUniqueNameError, id:
            print 'already had id:', id

        suitcase = kos.get_suitcase()
        if '-u' in sys.argv:
            reg.UnloadStaticContent(id)
            reg.UnRegisterProvider(id)
        else:
            reg.UploadStaticContent(id, suitcase.repr)
