import sys, os; sys.path.insert(0, os.path.join(sys.path[0], "../../"))

from koe.common import kpapp, kptools, ilutools
import graphkp

class Launcher:

    def __init__(self):
        self.mgr = kpapp.KPManager()

    def launch(self):
        # the KP __init__ will parse sys.argv
        inst = graphkp.KP()
        kp = self.mgr.construct(inst, ["graphkp", "pagegraph", "link",
                                       "crawler", "exclude"])  
        self.mgr.send(kptools.default_kernel(), kp, self.displayResults)
        ilutools.RunMainLoop()
                                            
    def displayResults(self, inst, id, reason, details, kprepr):
        try:
            if reason:
                print reason, ":", details
                print self.mgr.get_traceback(kprepr)
                return
            for url, page in inst.graph.items():
                print url
                if hasattr(page, 'title'):
                    print "\t", "Title:", page.title
                if page.children:
                    print "\t", "num. of internal links", len(page.children)
                if page.extChildren:
                    print "\t", "num. external links", len(page.extChildren)
                print
        finally:
            ilutools.ExitMainLoop()

if __name__ == "__main__":
    Launcher().launch()
