"""Implementation for the robot exclusion protocol.

"""

# XXX should replace with re
import regex
import string
import urlparse

class Policy:

    def __init__(self):
	self.disallow = []
	self.uarx = regex.compile('user-agent:[ ]?\(.*\)', regex.casefold)
	self.disrx = regex.compile('disallow:[ ]?\(.*\)', regex.casefold)

    def __getstate__(self):
	return map(lambda t:t[0], self.disallow)

    def __setstate__(self, state):
	self.disallow = map(lambda s:(s, regex.compile(s)), state)

    def parse(self, txt, useragent):
	# txt should be a list of strings
	useragent = string.strip(useragent)
	l = len(useragent)
	rec = 0
	applies = 0
	for line in txt:
	    if line and line[0] == '#':
		continue
	    if self.uarx.search(line) >= 0:
		if rec == 1:
		    applies = 0
		    rec = 0
		val = self.uarx.group(1)
		if string.strip(val)[:l] == useragent:
		    applies = 1
		elif string.strip(val) == '*':
		    applies = 1
	    elif self.disrx.search(line) >= 0:
		rec = 1
		if applies:
		    path = self.disrx.group(1)
		    try:
			rx = regex.compile(string.strip(path))
		    except regex.error:
			pass
		    else:
			self.disallow.append((path, rx))
			
    def allows(self, url):
	path = urlparse.urlparse(url)[2]
	for rxpath, rx in self.disallow:
	    if rx.match(path) >= 0:
		return 0
	return 1
