import pagegraph
import link
import crawler

import string
import pickle

import urllib
try:
    # normal Python script
    urlopen = urllib.URLopener().open
except AttributeError:
    # KPRExec proxy
    urlopen = urllib.urlopen

class kpCrawler(crawler.DiameterLimitCrawler):
    def __init__(self, root, diameter, width):
        crawler.superInit(crawler.DiameterLimitCrawler, self, root,
                          diameter, width)
        crawler.TitleGrabber(self)
        
    def initGraph(self, root):
        self.graph = pagegraph.GraphNoExternalLinks(root)

    def initURLopen(self):
        self.urlopen = urlopen

class KP:
    def __init__(self):
        self.diameter = 3
        self.width = 25
        # process KP arguments
        import sys
        import getopt
        opts, args = getopt.getopt(sys.argv[1:], 'vd:w:')
        for k, v in opts:
            if k == '-v':
                crawler.VERBOSE = 1
            elif k == '-d':
                self.diameter = string.atoi(v)
            elif k == '-w':
                self.width = string.atoi(v)
        self.baseURL = args[0]
        
    def __main__(self, kos):
        robot = kpCrawler(self.baseURL, self.diameter, self.width)
        robot.crawl()
        self.graph = robot.graph
        kos.checkpoint()
        # would like to just put this in the suitcase, but we can't
        # pickle it

