"""A fun demo to watch with many KOSs and the Visualizer running.

Two optional arguments: [-s sleeptime] [-f fuel]

Where

    sleeptime is the time to sleep between migrations, expressed as a float
    appropriate for time.sleep()

    fuel is the maximum number of times a KP can either migrate or clone

"""

import time
import whrandom
import nstools


class KP:
    def __init__(self):
        self.__fuel = 50
        self.__sleeptime = None

    def __main__(self, kos):
        me = kos.get_kphandle()
        if self.__sleeptime is None:
            # only do this when newly born
            self.__sleeptime = 0
            import sys
            import getopt
            opts, args = getopt.getopt(sys.argv[1:], 's:f:')
            for opt, arg in opts:
                if opt == '-s':
                    try: self.__sleeptime = float(arg)
                    except ValueError: pass
                elif opt == '-f':
                    try: self.__fuel = int(arg)
                    except ValueError: pass
        else:
            # we have been reconstituted
            self.__fuel = self.__fuel - 1
            if self.__fuel <= 0:
                print me, 'spent!'
                return
            time.sleep(self.__sleeptime)
        self.decide(kos, me)

    def decide(self, kos, me):
        # decide what to do.  we can either clone, migrate, or exit.  weight
        # heavily in favor of migrating, but be sure we do a little cloning
        kosnames = nstools.WorldOpen('kos').List()
        decision = whrandom.random()
        if decision < 0.5:
            # We're going to clone ourselves.  Each KP gets half the current
            # amount of fuel
            self.__fuel = self.__fuel / 2
            print me, 'cloning'
            kos.clone()
            self.decide(kos, me)
        else:
            print me, 'migrating'
            while 1:
                try:
                    kos.migrate(whrandom.choice(kosnames))
                    # never get here
                except kos.MigrationError:
                    pass
