"""Nomadic demo.  Visit kernels until lives run out.  Duplicates okay.

Arguments:
    -s [sleeptime]
    -l [lives]
    -q

sleep is the amount of time (in seconds) to sleep at each node before
migrating on -- default is 0. lives is the number of hops to make -- default
is 25.

-q says to migrate quietly
"""

import nstools
import time
import string
import whrandom



class KP:
    def __init__(self):
        self.__lives = 25
        self.__sleeptime = None

    def __main__(self, kos):
        # only do this when newly birthed
        if self.__sleeptime is None:
            self.__sleeptime = 0
            self.__quiet = 0
            import sys
            import getopt
            opts, args = getopt.getopt(sys.argv[1:], 's:l:q')
            for k, v in opts:
                if k == '-s': self.__sleeptime = string.atof(v)
                if k == '-l': self.__lives = string.atoi(v)
                if k == '-q': self.__quiet = 1
        else:
            self.__lives = self.__lives - 1
            if self.__lives <= 0:
                if not self.__quiet:
                    print 'No longer a nomad... CYA!'
                return
        if not self.__quiet:
            print self.__lives, 'lives left'
        if self.__sleeptime > 0:
            if not self.__quiet:
                print 'sleeping for %g seconds...' % self.__sleeptime
            time.sleep(self.__sleeptime)
        # get list of kernels
        ns = nstools.WorldOpen('kos')
        l = ns.List()
##      # 75% of the time, guarantee we migrate away from home, but
##      # only if there is more than one kernel around
##      if len(l) > 1 and whrandom.random() < 0.75:
##          l.remove(kos.get_kos_name())
        if l:
            while 1:
                k = whrandom.choice(l)
                # migrate
                if not self.__quiet:
                    print 'heading off to', k, '... ',
                try:
                    kos.migrate(k)
                    # should never get here
                except kos.MigrationError:
                    if not self.__quiet:
                        print "DIDN'T GET THERE!"
        else:
            if not self.__quiet:
                print 'no one to migrate to!'

