import types

class GenericWrapper:

    def __init__(self, object):
        self.object = object

    def Exists(self, name):
        if self.getfunc(name):
            return 1
        else:
            return 0

    def Describe(self, name):
        f = self.getfunc(name)
        if not f:
            return ""
        try:
            return f.__doc__ or ""
        except AttributeError:
            return ""

    def Call(self, name, args):
        f = self.getfunc(name)
        if not f:
            return "InvalidFunction", [str(name)]
        try:
            result = f(args)
        except:
            excname = sys.exc_type
            if type(excname) is types.ClassType:
                excname = excname.__name__
            return excname, self.normvalues(sys.exc_value)
        else:
            return "", self.normvalues(result)

    def getfunc(self, name):
        if not name or name[0] == '_':
            return None
        try:
            f = getattr(self.object, name)
        except AttributeError:
            return None
        if type(f) is not types.MethodType or not f.__doc__:
            return None
        return f

    def normvalues(self, result):
        if result is None:
            result = []
        elif type(result) is types.StringType:
            result = [result]
        else:
            if type(result) != types.ListType:
                try:
                    result = tuple(result)
                except:
                    result = [result]
            result = map(str, result)
        return result
