"""Mapping implementation.  See Mapping.isl"""

from koe.interfaces.stubs import Mapping, Mapping__skel



class StringMap(Mapping__skel.StringMap):
    def __init__(self, dict=None):
        if dict is None:
            self.__d = {}
        else:
            self.__d = dict

    def get_dict(self):
        return self.__d

    #
    # API
    #

    def GetKeys(self):
        return self.__d.keys()

    def GetValue(self, key):
        try:
            return self.__d[key]
        except KeyError:
            raise Mapping.KeyError, key

    def GetItems(self):
        return self.__d.items()

    def SetValue(self, key, value):
        self.__d[key] = value

    def DeleteKey(self, key):
        try:
            del self.__d[key]
        except KeyError:
            raise Mapping.KeyError, key
