"""Suitcase tools.

load_suitcase(kos) -- return a dictionary with the contents of the suitcase.

"""

def load_suitcase(kos=None, sfs=None):
    sfs = sfs or kos.get_suitcase()
    return load_suitcase_dir(sfs, "/")

def load_suitcase_dir(sfs, path):
    dict = {}
    names = sfs.listdir(path)
    names.sort()
    # XXX Remove duplicates reported by listdir bug
    for name in names[:]:
        if names.count(name) > 1:
            names.remove(name)
            continue
        fname = sfs.path.join(path, name)
        if sfs.path.isdir(fname):
            dict[name] = load_suitcase_dir(sfs, fname)
        else:
            dict[name] = load_suitcase_file(sfs, fname)
    return dict

def load_suitcase_file(sfs, path):
    f = sfs.open(path)
    data = f.read()
    n = len(data)
    f.close()
    if n and n < 80:
        r = `data`
    if data[-1:] == '\n':
        data = data[:-1]
    return data
