(* A simplified interface to AGS access of the KOE service via rate.d *)

INTERFACE AGSAPI;

TYPE String = ilu.CString;

(* The IP address of the AGS to contact, via broadcast *)
TYPE Address = String;

(* The port number of the AGS's rate.d process *)
TYPE Port = INTEGER;

(* The returned contact information, e.g. SBH or kernel name *)
TYPE ContactInfo = String;

(* If for any reason the RFS fails, this exception is raised *)
EXCEPTION RFSError : String
    "Failure to get a response to the RFS";


TYPE AGS = OBJECT
    METHODS
        RequestService(addr : Address, port : Port)
	    : ContactInfo
	RAISES RFSError END
	"Request the KOE service of an AGS at the given address and port."
    END;
