(* Interface specification for communication with the dbindex-based Elhill
 * database implementation.
 *
 * $Version$
 * $Source: /projects/cvsroot/koe/src/koe/interfaces/GeeHill.isl,v $
 *)

INTERFACE GeeHill;

TYPE String = ilu.CString;
TYPE RecordID = String;

EXCEPTION UnknownRecord : String
	"fetch*() called with unknown RecordID value";

EXCEPTION BadTerm : String
	"Badly formed search term";

TYPE SearchTerm = RECORD
	negated : BOOLEAN,
	term : String,
	field : String
END;

TYPE ANDExpression = SEQUENCE OF SearchTerm;

TYPE ORExpression = SEQUENCE OF ANDExpression;

TYPE SearchResult = SEQUENCE OF RecordID;

TYPE LongRec = RECORD
	TI : String,
	AU : String,
	AD : String,
	JL : String,
	YR : String,
	AB : String,
	MH : String,
	UI : String,
	RN : String,
	LA : String,
	PT : String,
	SO : String
END;

TYPE ShortRec = RECORD
	TI : String,
	UI : String
END;

TYPE MEDLINE = OBJECT

	METHODS

	search(Expression : ORExpression) : SearchResult
	  RAISES BadTerm END
	  "Perform a search based on SearchExpression",

	searchCount(Expression : ORExpression) : Integer
	  RAISES BadTerm END
	  "Return number of matches for SearchExpression",

	fetchRecord(ui : RecordID) : LongRec
	  RAISES UnknownRecord END
	  "Fetch a single record from a search",

	fetchUITI(ui : RecordID) : ShortRec
	  RAISES UnknownRecord END
          "Fetch the UI and TI fields from a single record from a search"

	END;
