(* Generic interface. *)

(* $Id: GenericAPI.isl,v 1.2 1998/09/17 15:59:13 fdrake Exp $ *)


INTERFACE GenericAPI;

TYPE String = ilu.CString;
TYPE Value = SEQUENCE OF BYTE;
TYPE ValueList = SEQUENCE of Value;

TYPE Generic = OBJECT
               METHODS
	         Exists(function: String): Boolean
		   "Ask whether a given function is defined"

		 ,
		 
		 Describe(function: String): String
		   "Return the documentation string for the function"

		 ,
		 
                 Call(function: String, arguments: ValueList,
		      OUT result: ValueList): String
		   "Call the given function with the given argument list"
		 
               END;
