(*  Interface to the GUI KP launcher tool that allows externally launcher
 *  KPs to use the launcher as a reporting station and output server.
 *
 *  $Revision: 1.1 $
 *  $Source: /projects/cvsroot/koe/src/koe/interfaces/MonitorAPI.isl,v $
 *)

INTERFACE MonitorAPI IMPORTS KOS END;

TYPE ReporterInfo = RECORD
	  binding-handle:	KOS.SBH,
	  reporting-id:		KOS.String,
	  stdout-server:	KOS.SBH,
	  stderr-server:	KOS.SBH
	END;

TYPE MonitorServer = OBJECT
	DOCUMENTATION
	  "Public interface to the GUI KP monitoring tool."

	METHODS
	  RequestReporter(prefix: KOS.String, ioserver: BOOLEAN): ReporterInfo
	    RAISES KOS.AuthorizationError END
	    "Request a reporting 'context' for a single KP."
	END;
