(* A very simple data player interface
 *
 * $Revision: 1.6 $
 * $Source: /projects/cvsroot/koe/src/koe/interfaces/PlayerAPI.isl,v $
 *)
 
INTERFACE PlayerAPI;

TYPE String = ilu.CString;
TYPE Data = SEQUENCE OF BYTE;

EXCEPTION ImageError : String
    "Unable to play image";
EXCEPTION AuthorizationFailed : String
    "Decryption key required";


TYPE ImagePlayer = OBJECT
    COLLECTIBLE
    METHODS
        SetImageName(name: String),

	SetImageData(image: Data),

	Play()
	    RAISES ImageError END,

	Close()
    END;


TYPE DecryptPlayer = OBJECT
    SUPERTYPES ImagePlayer END

    METHODS
        SetImageKey(key : Data),

	Play()
	    RAISES ImageError, AuthorizationFailed END
    END;


TYPE PlayerFactory = OBJECT
    METHODS
        GetNewPlayer() : ImagePlayer
	    "Returns new player for displaying a single picture."
    END;
