(* A Simple IO plugin interface for Knowbot Programs
 *)
 
(* $Id: SimpleIOAPI.isl,v 1.2 1997/01/02 16:46:22 bwarsaw Exp $ *)
(* $Source: /projects/cvsroot/koe/src/koe/interfaces/SimpleIOAPI.isl,v $ *)

INTERFACE SimpleIOAPI IMPORTS FileAPI END;

TYPE String = ilu.CString;

EXCEPTION SpawnError : String
    "Failure to create a SimpleIO object";


TYPE SimpleIOFactory = OBJECT
    METHODS
        GetNewSimpleIO() : FileAPI.File
    	    RAISES SpawnError END
	    "Returns a new SimpleIO object, which has File semantics.",

        GetNewSimpleIOHW(height: INTEGER, width: INTEGER) : FileAPI.File
	  (* XxX This might not be necessary if OPTIONAL ILU args can
	     work the way i expect them to, but i don't have the time right
	     now to figure it out *)
	    RAISES SpawnError END
	    "Like GetNewSimpleIO, but with designated height and width."

    END;
