"""ILU Alarm management object"""

import traceback
import ilu

class Alarm:
    __armed = 0

    def __init__(self, interval=0.100, debug=None):
        self.__alarm = ilu.CreateAlarm()
        self.__interval = ilu.FineTime(interval)
        self.__cblist = []
        self.__debug = debug

    def arm(self):
        self.__alarm.set(ilu.FineTime_Now() + self.__interval,
                         self.__doalarm, ())
        self.__armed = 1

    def close(self):
        self.__armed = 0
        self.__alarm.unset()

    def register(self, cb):
        self.__cblist.append(cb)

    def __doalarm(self):
        if self.__armed:
            if self.__debug:
                print self.__debug,
            for cb in self.__cblist:
                try:
                    cb()
                # don't count on the os._exit(0)'s working!
                except MemoryError:
                    print 'FATAL: Memory exhausted!'
                    os._exit(0)
                except (ilu.IluGeneralError, ilu.IluProtocolError):
                    print 'We lost our Worldroot'
                    os._exit(0)
                except:
                    print 'WARNING: Exception in Visualizer alarm callback'
                    traceback.print_exc()
            self.arm()
