#! /usr/bin/env python

"""A plugin which interfaces with the AGS rate.d client library.

"""

import sys
from koe.common import pluginlib
from koe.common import ratedlib
from koe.interfaces.stubs import AGSAPI
from koe.interfaces.stubs import AGSAPI__skel



# KOE Plugin boilerplate
def main():
    kos, ns = pluginlib.register('AGS')
    agsimpl = AGSImpl()
    svcid = kos.bind_service('AGS', agsimpl, 'AGSAPI.AGS')
    kos.run()
    kos.unbind_service(svcid)
    sys.exit(0)



# Interface wrapper
class AGSImpl(AGSAPI__skel.AGS):
    def __init__(self):
        self.__rclient = ratedlib.RatedClient()

    # ISL interface
    #
    def RequestService(self, addr, port):
        try:
            r = self.__rclient.requestService(addr, port)
        except ratedlib.RatedTimeoutError:
            raise AGSAPI.RFSError, 'timeout'
        except ratedlib.RatedInvalidFDError:
            raise AGSAPI.RFSError, 'invalid read file descriptor'
        else:
            if not r:
                raise AGSAPI.RFSError, 'empty host returned'
            return r



if __name__ == '__main__':
    main()
