
#
# This module implements an Elhill telnet expect session as an ILU true server
#
from koe.interfaces.stubs import ElhillController__skel
import elhill
import ilu
import sys

from koe.common import ilutools


class MEDLINE(ElhillController__skel.MEDLINE):
    """Implement the thin verneer needed between module Elhill__skel.py
       and elhill.py"""
    
    def __init__(self, delegate=None):
        """Instantiate an elhill.Comm_Control to perform the work this
           class must do"""
        self.cc = elhill.MEDLINE_Control(delegate)

    def close(self):
        self.cc.close()
        
    def connect(self, exp=None, debug=0, logins=None):
        return self.cc.connect(exp, debug, logins)
        
    def fetchRecord(self, RecNum):
        return self.cc.fetchRecord(RecNum)

    def fetchUITI(self, RecNum):
        return self.cc.fetchUITI(RecNum)
        
    def search(self, Expression):
        return self.cc.search(Expression)

def main(argv):
    
    if (len(argv) < 2):
        print 'Server => Usage:  python ElhillServer.py SERVER-ID'
        sys.exit(1)

    # Create the kernel server with the appropriate ID
    server = ilu.CreateServer(argv[1])

    # Create an instance of the Elhill communications controller class
    comm = MEDLINE()

    # Publish it's existance using the Simple Binding Service
    # comm.IluPublish()

    # For convenience, print the string binding handle of the new instance
    # print 'Server => ElhillController instance published.'
    print 'Server => ElhillController SBH is "' + comm.IluSBH() + '"'

    ilutools.RunMainLoop()
    
if __name__ == "__main__":
    main(sys.argv)


