import sys, os; sys.path.insert(0, os.path.join(sys.path[0], "../../"))
from koe.common import pathhack
# More path munging so we can import the elhill module
sys.path.append(os.path.join(pathhack.kos_root(), "demos/medline"))

from koe.common import pluginlib

import elhill
from koe.common import ilutools

services = ["Elhill"]

def main():
    kos, ns = pluginlib.register('Elhill')
    ids = []
    for service in services:
        id = kos.bind_service(service, MEDLINE(), "ElhillController.MEDLINE")
        ids.append(id)
    kos.run()
    for id in ids:
        kos.unbind_service(id)
    sys.exit(0)


class MEDLINE:
    def __init__(self, delegate=None):
        """Instantiate an elhill.MEDLINE_Control to perform the work this class must do"""
        self.cc = elhill.MEDLINE_Control(delegate)

    def close(self):
        self.cc.close()
    
    def connect(self, Logins):
        return self.cc.connect(Logins)
        
    def fetchRecord(self, RecNum):
        return self.cc.fetchRecord(RecNum)

    def fetchUITI(self, RecNum):
        return self.cc.fetchUITI(RecNum)
        
    def search(self, Expression):
        return self.cc.search(Expression)

if __name__ == "__main__":
    main()

