"The IFinder plugin sends this KP to look for services."

try:
    import koe.common.nstools
    nstools = koe.common.nstools
except ImportError:
    import nstools
    
 
class InterfaceFinderKP:
 
    def __init__(self, interface="", places=[]):
        # nothing in the constructor when we do unpickling
        # __setstate__ will clobber the default values
        self.interface = interface
        self.places = places
        self.found = {}
 
    def __main__(self, kos):
        """Finds services available here, then migrates to a new KOS."""
        self.find_services(kos, self.interface)
        if self.places:
            next = self.places[0]
            self.places.remove(next)
            kos.migrate(next)
        else:
            kos.checkpoint()
 
    def find_services(self, kos, service_type):
        """Save a list of available services in the suitcase"""
        service_names = kos.list_services(service_type)
        kos_name = kos.get_kos_name()
        self.found[kos_name] = service_names
