"""Simple demonstration of a client.  See also server.py.

This uses the standard Seller1 interface (types/Seller1.isl) which
defines the Seller object type.  Seller objects have a single method
price(), taking no arguments, returning an integer.

Our demo client simply looks up a specific seller, requests its price
and prints it.

We will be hit by lightning (actually a ValueError exception) if our
seller isn't registered.

"""

NAME = "simple-client-server-demo"

class KP:

    def __main__(self, kos):
        # Get the seller's descriptor
        sellerd = kos.lookup_service("Seller1.Seller", NAME)
        # Open a connector to the seller
        seller = sellerd.Open()
        # Request and print the price
        price = seller.price()
        print "Client got price:", `price`
