"""Example of a KP that raises an exception in a trigger callback."""

import sys
import time

class KP:
    __inclone_p = None
    __varname = 'kicker'
    __condvar = None

    def __main__(self, kos):
        self.__kos = kos
        if not self.__inclone_p:
            # pre-clonage.  create a condition variable and register a
            # trigger on it
            self.__condvar = kos.create_condition(self.__varname)
            self.__inclone_p = 1
            kos.clone()
            #
            # in the parent
            #
            kos.register_trigger(self.__condvar, self.handle_trigger)
            kos.run()
            # never returns
        else:
            # in the clone
            kos.broadcast(self.__condvar)
            sys.exit()

    def handle_trigger(self, phantom_arg):
        # this causes a TypeError because the callback only takes one
        # argument  
        print 'handle_trigger'
