"""Example of a KP that sys.exit's from a trigger callback."""

import sys
import time

class KP:
    __inclone_p = None
    __varname = 'kicker'
    __condvar = None

    def __main__(self, kos):
        self.__kos = kos
        if not self.__inclone_p:
            # pre-clonage.  create a condition variable and register a
            # trigger on it
            self.__condvar = kos.create_condition(self.__varname)
            self.__inclone_p = 1
            kos.clone()
            #
            # in the parent
            #
            kos.register_trigger(self.__condvar, self.handle_trigger)
            kos.run()
            print "falling off end of __main__"
            # the stop() in handle_trigger() returns us to here
        else:
            # in the clone
            kos.broadcast(self.__condvar)
            sys.exit()

    def handle_trigger(self):
        # note cannot use sys.exit() here, since the exception isn't
        # propagated back to the caller.
##      sys.exit()
        print "in trigger handler"
        self.__kos.stop()
