import sys
import GenericImpl

class MyObject:
    def __init__(self, kos):
        self.kos = kos
    def echo(self, args):
        "echo arguments back unchanged"
        print "echo(%s)" % str(args)
        return args
    def stop(self, args):
        "stop serving"
        self.kos.stop()

if not sys.argv[1:] or sys.argv[1] not in ("-s", "-c", "-q"):
    print "Usage: submit generic.py -- (-s|-c|-q) [args]"
    sys.exit(2)

name = "gvr-generic-test-server"
type = "GenericAPI.Generic"

class Server:
    def __main__(self, kos):
        object = MyObject(kos)
        wrapper = GenericImpl.GenericWrapper(object)
        descr = kos.bind_service(name, wrapper, type)
        print "serving..."
        kos.run()

class Client:
    def __main__(self, kos):
        stub = kos.lookup_service(type, name).Open()
        print stub.Call("echo", sys.argv[2:])
        if sys.argv[1] == "-q":
            stub.Call("stop", [])

if sys.argv[1] == "-s":
    KP = Server
else:
    KP = Client
