"""Exercise the iotools module."""

import string
import iotools

class KP:
    __iofp = None

    def __main__(self, kos):
        fresh = 0
        if not self.__iofp:
            self.__iofp = iotools.get_io_mechanism(kos)
            fresh = 1
        if fresh:
            kos.migrate(kos.get_kos_name())
        else:
            self.do_test(kos)

    def do_test(self, kos):
        #
        # test output
        #
        self.__iofp.write('testing write()\n')
        self.__iofp.writelines(['testing writelines()\n',
                                'one\n',
                                'two\n',
                                'three\n'])
        #
        # test input
        #
        self.__iofp.write('testing read(), enter up to 1024 characters\n')
        text = self.__iofp.read(1024)
        self.__iofp.write('ECHO: %s\n' % text)
        self.__iofp.write('testing readline(), enter a line of stuff\n')
        text = self.__iofp.readline()
        self.__iofp.write('ECHO: %s\n' % text)
        self.__iofp.write('testing readlines(), hit EOF when finished\n')
        text = self.__iofp.readlines()
        self.__iofp.write('ECHO: %s\n' % text)
        #
        self.__iofp.write('Done?\n')
        self.__iofp.readline()
        self.__iofp.close()
