"""This demo shows that connectors can be migrated."""

import random
import nstools
import time

class KP:

    def __init__(self):
        self.io = None
        self.lives = 9
        self.visited = []
        self.kos = None

    def __main__(self, kos):
        self.lives = self.lives - 1
        if not self.kos:
            self.kos = kos
        else:
            if self.kos is kos:
                print "Migrated kos correctly"
            else:
                print "Didn't migrate kos correctly!!!!"

        # Create IO console (a migratable connector)
        if not self.io:
            try:
                siocd = kos.lookup_service("SimpleIOAPI.SimpleIOFactory",
                                           "simpleio")
            except nstools.BadPathError, msg:
                print "*** Cannot run this test:", msg
                return
            sio = siocd.Open()
            self.io = sio.GetNewSimpleIO()
            self.io.write("Console created...\n")

        # Show greeting message
        name = kos.get_kos_name()
        self.io.write("Arriving on %s (%d lives left)\n" % (name, self.lives))
        self.visited.append(name)

        # get list of potential targets
        ns = kos.get_namespace()
        kernels = nstools.Lookup(ns, 'world/kos').Open().List()
        todo = []
        for k in kernels:
            if k not in self.visited:
                todo.append(k)

        # Migrate -- maybe
        if self.lives <= 0:
            self.io.write("No lives left.  Bye!\n")
        elif not todo:
            self.io.write("No new targets.  Bye!\n")
        else:
            target = random.choice(todo)
            self.io.write("Migrating to %s ...\n" % target)
            kos.migrate(target)

        # Not migrated -- close the IO console
        self.io.write("This window will autodestruct in 2 seconds.\n")
        time.sleep(1)
        self.io.write("This window will autodestruct in 1 second.\n")
        time.sleep(1)
        self.io.close()
