"""Migrate repeatedly to the kernel we're on.

Suitcase files are consulted to determine defaults.  The file
`sleeptime' contains an integer of the amount of time (in seconds) to
sleep at each node before migrating on -- default is zero seconds.
The file 'lives' contains an integer of the number of times to
migrate -- default is 9.

"""

import nstools
import time
import string



class KP:
    def __init__(self):
        self.__lives = 9
        self.__home = None
        self.__sleeptime = None

    def __main__(self, kos):
        # only do this when newly birthed
        if self.__home is None:
            self.__home = kos.get_kos_name()
            sfs = kos.get_suitcase()
            try:
                fp = sfs.open('sleeptime', 'r')
                self.__sleeptime = string.atof(string.strip(fp.read()))
                fp.close()
            except (IOError, ValueError), msg:
                self.__sleeptime = 0
            try:
                fp = sfs.open('lives', 'r')
                self.__lives = string.atoi(string.strip(fp.read()))
                fp.close()
            except (IOError, ValueError), msg:
                self.__lives = 9
        self.__lives = self.__lives - 1
        if self.__lives < 0:
            'Guess I done hoppin home!'
            return
        if self.__sleeptime > 0:
            print 'sleeping for %g seconds...' % self.__sleeptime
            time.sleep(self.__sleeptime)
        # migrate
        print 'heading home to', self.__home
        kos.migrate(self.__home)
