"""New Migrate demo which tries to visit every kernel.

A suitcase file is consulted to determine defaults.  The file
`sleeptime' contains an integer of the amount of time (in seconds) to
sleep at each node before migrating on -- default is zero seconds.

"""

import nstools
import time
import string



class KP:
    def __init__(self):
        self.__hopcount = 0
        self.__visited = []
        self.__sleeptime = None

    def __main__(self, kos):
        # only do this when newly birthed
        if self.__sleeptime is None:
            sfs = kos.get_suitcase()
            try:
                fp = sfs.open('sleeptime', 'r')
                self.__sleeptime = string.atoi(string.strip(fp.read()))
                fp.close()
            except (IOError, ValueError), msg:
                self.__sleeptime = 0
        self.__hopcount = self.__hopcount + 1
        print 'hop', self.__hopcount
        if self.__hopcount > 10:
            print "guess I've roamed around enough"
            return
        # get list of kernels
        print 'sleeping for %d seconds...' % self.__sleeptime
        time.sleep(self.__sleeptime)
        ns = kos.get_namespace()
        kernels = nstools.Lookup(ns, 'world/kos').Open().List()
        for k in kernels:
            if k not in self.__visited:
                self.__visited.append(k)
                break
        else:
            print "I've been everywhere:", self.__visited
            return
        # migrate
        print 'heading off to', k
        kos.migrate(k)
