"""Slightly more complex demonstration of a server.

See also server.py, client.py, and multiclient.py.

This demo builds on the example in server.py by getting the service
name, fixed price and maximum number of calls from the KP's suitcase
data.

"""

import string
import sctools

class KP:

    def __main__(self, kos):
        # Instantiate the service implementation
        impl = MySellerImpl(kos)
        name = impl.name
        print "service name:", name
        # Bind the service implementation to a connector
        id = kos.bind_service(name, impl, "Seller1.Seller")
        # Start the service main loop
        print "Serving with id =", `id`, "..."
        kos.run()
        print "Goodbye"

class MySellerImpl:

    def __init__(self, kos):
        self.kos = kos
        self.ncalls = 0
        self._get_parameters()

    def _get_parameters(self):
        scdict = sctools.load_suitcase(self.kos)
        # The following three suitcase items must exist
        self.name = scdict['name']
        self.fixedprice = string.atoi(scdict['price'])
        self.maxcalls = string.atoi(scdict['maxcalls'])

    def price(self):
        self.ncalls = self.ncalls + 1
        print "Price requested; this is call", self.ncalls
        if self.ncalls >= self.maxcalls:
            print "Calling it quits"
            self.kos.stop()
        return self.fixedprice
