"""Simple demonstration of a server.  See also client.py.

This uses the standard Seller1 interface (types/Seller1.isl) which
defines the Seller object type.  Seller objects have a single method
price(), taking no arguments, returning an integer.

Our demo server returns the constant 1 from its price() method
implementation.

After the price has been requested three times, the demo server quits.

"""

NAME = "simple-client-server-demo"
PRICE = 1
MAXCALLS = 3

class KP:

    def __main__(self, kos):
        # Instantiate the service implementation
        impl = MySellerImpl(kos)
        # Bind the service implementation to the connector "simple-seller"
        id = kos.bind_service(NAME, impl, "Seller1.Seller")
        # Start the service main loop
        print "Serving with id =", `id`, "..."
        kos.run()
        print "Goodbye"

class MySellerImpl:

    def __init__(self, kos):
        self.kos = kos
        self.ncalls = 0

    def price(self):
        self.ncalls = self.ncalls + 1
        print "Price requested; this is call", self.ncalls
        if self.ncalls >= MAXCALLS:
            print "Calling it quits"
            self.kos.stop()
        return PRICE
