import KOS
import nstools
import time

class KP:
    """Wander around and do some suitcase I/O at each KOS."""

    def __init__(self):
        self.maxhops = 20       #  *probably* hit all before we 100 hops
        self.hopcount = 0
        self.been = {}

    def __main__(self, kos):
        where = kos.get_kos_name()
        self.been[kos.get_kos_name()] = 1
        self.hopcount = self.hopcount + 1

        # create several files
        t0 = time.time()
        sfs = kos.get_suitcase()
        sfs.mkdir(where)
        f1 = sfs.open('/%s/types' % where, 'w')
        f2 = sfs.open('/%s/services' % where, 'w')
        for type in kos.list_service_types():
            f1.write('%s\n' % type)
            for serv in kos.list_services(type):
                f2.write('%s: %s\n' % (type, serv))
        f1.close()
        f2.close()
        f3 = sfs.open('/%s/data' % where, 'w')
        for i in range(16):
            f3.write(chr(i*2+32) * 12)
        f3.close()
        t1 = time.time()
        print "Suitcase time", t1 - t0

        kosnames = nstools.WorldOpen('kos').List()
        notbeen = []
        for name in kosnames:
            if not self.been.has_key(name):
                notbeen.append(name)

        if not notbeen or self.hopcount > self.maxhops:
            return

        for name in notbeen:
            try:
                kos.migrate(name)
            except (KOS.CommunicationError, KOS.ResourceError), msg:
                # try again
                pass
