"""Create lots of KPs and have them run around.

The intent is to make sure the kernel can cope with *many* KPs running
at the same time.
"""

import sys
import whrandom
import KOS
import nstools
import time

class KP:

    def __init__(self):
        self.num_kps = 3
        self.num_hops = 10
        self.count = 0
        self.suitcase = None
        self._init_kps = 3
        self._init_hops = 10
        self.been = []

    def __main__(self, kos):
        self.check_suitcase(kos)
        if self.num_kps > 0:
            self.num_kps = self.num_kps - 1
            kos.clone()
        if self.num_hops > 0:
            here = kos.get_kos_name()
            self.num_hops = self.num_hops - 1
            self.count = self.count + 1
            kos.migrate(here)
        self.been.append(kos.get_kos_name())
        self.go_somewhere_else(kos)

    def go_somewhere_else(self, kos):
        kernels = nstools.WorldOpen('kos').List()
        notbeen = []
        for k in kernels:
            if not k in self.been:
                notbeen.append(k)
        if notbeen:
            new_kos = whrandom.choice(notbeen)
            self.num_hops = self._init_hops
            while 1:
                try:
                    kos.migrate(new_kos)
                    # should never get here
                except kos.MigrationError:
                    pass

    def check_suitcase(self, kos):
        if self.suitcase is None:
            # read different init variables
            pass
