"""Simple demonstration of triggers.  See also triggerserver.py.

This looks through the condition variables of all other KPs (is there
a better way???) looking for ``our'' condition variable, and when
found, assigns it a value.  This is done for all KPs.

The triggerserver.py demo quits when its callback has fired three
times.

"""

NAME = "trigger-demo-variable"
VALUE = 0

import string
import nstools

class KP:

    def __main__(self, kos):
        # Get the KOS namespace
        ns = kos.get_namespace()
        me = kos.get_kphandle()
        try:
            var_descr = nstools.Lookup(ns, "kos/conditions/" + NAME)
        except nstools.BadPathError:
            print "%s: Can't find trigger %s" % (me, NAME)
        except:
            import sys
            print "(Exception: %s: %s)" % (sys.exc_type, sys.exc_value)
        else:
            print "%s: Triggering %s" % (me, NAME)
            # Get the variable
            var = var_descr.Open()
            # Set its value, triggering the server's callback
            kos.broadcast(var)

def numcmp(a, b):
    """Compare strings on numeric value if possible."""
    try:
        return cmp(string.atoi(a), string.atoi(b))
    except:
        return cmp(a, b)
