"""Simple demonstration of triggers.  See also triggerclient.py.

This creates a condition variable and registers a callback for it.
The callback prints the value; it quits when it has fired three times.

"""

NAME = "trigger-demo-variable"
VALUE = 0
MAXCALLS = 3

class KP:

    def __main__(self, kos):
        self.kos = kos
        self.varid = kos.create_condition(NAME)
        print "varid =", self.varid
        self.ncalls = 0
        kos.register_trigger(self.varid, self.callback)
        kos.run()

    def callback(self):
        self.ncalls = self.ncalls + 1
        print "Call number", self.ncalls
        if self.ncalls >= MAXCALLS:
            print "Calling it quits"
            self.kos.stop()
            print "Bye!"
        else:
            self.kos.register_trigger(self.varid, self.callback)
            print "Registration renewed"
