"""Class to display exception info for a KP."""

import Tkinter ; Tk = Tkinter
from koe.common import tktools


class ExceptionDialog(Tk.Toplevel):
    def __init__(self, master, repid, excp, value, traceback,
                 *args, **kw):
        if not kw.has_key("class_"):
            kw["class_"] = self.__class__.__name__
        apply(Tk.Toplevel.__init__, (self, master) + args, kw)
        self.title("Traceback from KP " + repid)
        self.iconname("Traceback: " + repid)
        fr, topfr, botfr = tktools.make_double_frame(self)
        Tk.Label(topfr, text=("%s: %s" % (excp, value))).pack()
        text, textfr = tktools.make_text_box(topfr, hbar=1, height=16,
                                             wrap=Tk.NONE)
        text.insert(Tk.END, traceback)
        text["state"] = Tk.DISABLED
        destroy = self.__destroy
        self.protocol("WM_DELETE_WINDOW", destroy)
        self.bind("<Alt-W>", destroy)
        self.bind("<Alt-w>", destroy)
        self.bind("<Return>", destroy)
        btn = Tk.Button(botfr, text="OK", command=destroy, default="active")
        side = None
        if tktools._inTkStep(self):
            side = Tk.RIGHT
        btn.pack(side=side)
        btn.focus_set()
        if master:
            tktools.set_transient(self, master)

    def __destroy(self, event=None):
        self.destroy()
        return 'break'
