"""Tk toplevel window that manages information about its exposure status
and binds handling for standard keys and window manager operations."""

import types
import Tkinter


class ExposableToplevel(Tkinter.Toplevel):
    __exposed = 1
    def __init__(self, master, exposed=1, **kw):
        apply(Tkinter.Toplevel.__init__, (self, master), kw)
        if not exposed:
            self.withdraw()
        self.bind("<Alt-W>", self.__withdraw_event)
        self.bind("<Alt-w>", self.__withdraw_event)
        self.protocol("WM_DELETE_WINDOW", self.__withdraw_event)

    def expose(self):
        if not self.__exposed:
            self.__exposed = 1
        self.deiconify()
        self.tkraise()

    def exposed_p(self):
        return self.__exposed

    def withdraw(self):
        if self.__exposed:
            self.__exposed = 0
            Tkinter.Toplevel.withdraw(self)

    def __withdraw_event(self, event=None):
        self.withdraw()
