#! /depot/gnu/plat/bin/perl

# Sorry there aren't more comments. Here's a start:
# Pass a log file on stdin. The output is a count of the results of
# each client iteration. First the total number of iterations. Then
# broken down by results: S means success. F means failure. Thus,
# SS means successful ping, successful call. FSF means failed ping,
# successful call, failed ping.

$count = 0;
# cases
$fs = 0;
$ffs = 0;
$fff = 0;
$ss = 0;
$sfs = 0;
$sff = 0;

while (<>) {
    $count++;
    if (/^\d+\s+([01]) ([01]) (.*)/o) {
	# we got an error
	if ($1 eq "1") {
	    if ($2 eq "1") {
		$sfs++;
	    } else {
		$sff++;
	    }
	} else {
	    if ($2 eq "1") {
		$ffs++;
	    } else {
		$fff++;
	    }
	}
    }
    elsif (/^\d+\s+0\s+(\d+)/) {
	# ping failed, but call succeeded
	$fs++;
    }
    elsif (!/EXIT/oi) {
	$ss++;
    }
}

print $count, "\n";
print "SS  ", $ss, "\t", $ss / $count, "\n" if ($ss != 0);
print "FS  ", $fs, "\t", $fs / $count, "\n" if ($fs != 0);
print "SFS ", $sfs, "\t", $sfs / $count, "\n" if ($sfs != 0);
print "SFF ", $sff, "\t", $sff / $count, "\n" if ($sff != 0);
print "FFS ", $ffs, "\t", $ffs / $count, "\n" if ($ffs != 0);
print "FFF ", $fff, "\t", $fff / $count, "\n" if ($fff != 0);
print "\n";
