#! /usr/bin/env python

# This documentation string also serves as a usage message
"""Kill Knowbot Program(s).

Usage: killkp.py [-k kernel] [-p password] [-s signal] kpid ...
"""


import sys, os; sys.path.insert(0, os.path.join(sys.path[0], "../../"))
import string
import getopt
##import ilu
from koe.interfaces.stubs import KOS
from koe.common import nstools
##import ilutools
from koe.common import kptools

import socket
DEFAULT_KERNEL = kptools.default_kernel()
del socket

DEFAULT_PASSWORD = "XXX"

import signal
DEFAULT_SIGNAL = signal.SIGTERM
del signal

def main():
    """Main program."""

    kernel = DEFAULT_KERNEL
    password = DEFAULT_PASSWORD
    signal = DEFAULT_SIGNAL
    try:
        opts, args = getopt.getopt(sys.argv[1:], "k:p:s:")
    except getopt.error, msg:
        print msg
        print __doc__
        sys.exit(2)
    for o, a in opts:
        if o == '-k': kernel = a
        if o == '-p': password = a
        if o == '-s':
            try:
                signal = string.atoi(a)
            except string.atoi_error:
                print "Signal is not an integer:", `a`
                print __doc__
                sys.exit(2)
    if not args:
        print "No kpid arguments"
        print __doc__
        sys.exit(2)
    receiver = nstools.WorldOpen("kos/%s/receiver" % kernel)
    sts = 0
    for kpid in args:
        print "Killing", kpid, "..."
        ok = 0
        try:
            receiver.KillKP(kpid, signal, password)
        except KOS.AuthorizationError, msg:
            print "Auth.Error:", msg
        except KOS.ResourceError, msg:
            print "Res.Error:", msg
        except:
            print "Unexpected error:", str(sys.exc_type)+":", sys.exc_value
        else:
            ok = 1
        if not ok:
            sts = 1
    sys.exit(sts)

if __name__ == '__main__':
    main()
