"""Proof-of-concept auctioneer, of backbone-tap bandwidth."""

import auctiontools
from Auctioneer import Auctioneer

AUCTION_TYPE = "MarketAPI.BasicAuctioneer"
AUCTION_NAME = "Bandwidth Auction"
AUCTION_KEY = "alacazam"                # XxX Not even close to a pgp key.

BIDDERS = ["MidBell", "BigCable", "TinyNet", "MidFed"]

class KP:
    def __main__(self, kos):
        print AUCTION_NAME + " revving up."
        a = auctioneer(kos, AUCTION_NAME, AUCTION_KEY)
        a.open_shop()

class auctioneer(Auctioneer):
    """Auction backbone access bandwidth."""

    def __init__(self, kos, name, private_key):
        Auctioneer.__init__(self, kos, name, private_key,
                            BIDDERS,
                            self.canned_lot())
        self.io.write(name + ": Setting up shop.\n")

    def canned_lot(self):
        """Create a dummy payload of items for auction."""

        # Assume:
        # T1 line is chunk 1 bandwidth (1.54MB/sec)
        # T3 line is chunk 30 bandwidth (45MB/sec)
        # ISDN is unit .01 bandwidth

        Item = auctiontools.Item
        items = [Item(name = 'parcel1',
                      owner = 'Nettap Inc.',
                      brief = "200 T1-scale connections",
                      details = "bandwidth: 200, chunk: 1",
                      price = 0,
                      minprice = 100,
                      openingprice = 120),
                 Item(name = 'parcel2',
                      owner = 'Nettap Inc.',
                      brief = "5 T3-scale connections",
                      details = "bandwidth: 150, chunk: 30",
                      price = 0,
                      minprice = 80,
                      openingprice = 100),
                 Item(name = 'parcel3',
                      owner = 'Nettap Inc.',
                      brief = "20000 ISDN-scale connections",
                      details = "bandwidth: 200, chunk: .01",
                      price = 0,
                      minprice = 50,
                      openingprice = 80),
                 Item(name = 'parcel4',
                      owner = 'Nettap Inc.',
                      brief = "400 T1-scale connections",
                      details = "bandwidth: 400, chunk: 1",
                      price = 0,
                      minprice = 300,
                      openingprice = 320)]
        return auctiontools.random_order(items)
