"""Proof-of-concept auction bidder - representative of telephone-company
constituency."""

import sys, os
import auctiontools
from Bidder import  Bidder

MY_TAG = "BigCable"                             # Cable-ish
MY_NAME = "BigCable Bidder"

SEEKING_BANDWIDTH = 800
CHUNK_PREF = 30                                 # T3-scale
MY_FUNDS = 500

AUCTION_TYPE = "MarketAPI.BasicAuction"
AUCTION_NAME = "Bandwidth Auction"

class KP:
    def __main__(self, kos):
        bidder = BigBidder(kos, MY_TAG, AUCTION_NAME,
                           MY_FUNDS, SEEKING_BANDWIDTH, CHUNK_PREF)
        bidder.run()

class BigBidder(Bidder):
    """Bid in auction, preferring parcels of mid-size bandwidth chunks."""

    OPPOSE = ["MidBell"]

    def __init__(self, kos, name, auction_name, funds, seeking_bandwidth,
                 chunk_pref):
        Bidder.__init__(self, kos, name, auction_name, funds)
        self.setfactors(bandwidth=seeking_bandwidth,
                        chunk=chunk_pref,
                        funds=funds)
