"""Proof-of-concept auction bidder - representative of telephone-company
constituency."""

import sys, os
import auctiontools
from Bidder import Bidder

MY_TAG = "MidBell"                              # Telco-ish
MY_NAME = "MidBell Bidder"

SEEKING_BANDWIDTH = 800
CHUNK_PREF = 1                                  # T1-scale
MY_FUNDS = 500

AUCTION_TYPE = "MarketAPI.BasicAuction"
AUCTION_NAME = "Bandwidth Auction"

class KP:
    def __main__(self, kos):
        bidder = MidBidder(kos, MY_TAG, AUCTION_NAME,
                           MY_FUNDS, SEEKING_BANDWIDTH, CHUNK_PREF)
        bidder.run()

class MidBidder(Bidder):
    """Bid in auction, preferring parcels of mid-size bandwidth chunks."""

    OPPOSE = ["BigCable"]

    def __init__(self, kos, name, auction_name, funds, seeking_bandwidth,
                 chunk_pref):
        Bidder.__init__(self, kos, name, auction_name, funds)
        self.setfactors(bandwidth=seeking_bandwidth,
                        chunk=chunk_pref,
                        funds=funds)
